'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceInTemplates = exports.runTasks = exports.getTasks = exports.getBuildSteps = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _gulp = require('gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _gulpPlumber = require('gulp-plumber');

var _gulpPlumber2 = _interopRequireDefault(_gulpPlumber);

var _gulpTap = require('gulp-tap');

var _gulpTap2 = _interopRequireDefault(_gulpTap);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _del = require('del');

var _del2 = _interopRequireDefault(_del);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _jsYaml = require('js-yaml');

var _jsYaml2 = _interopRequireDefault(_jsYaml);

var _index = require('./config/index.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// entry
exports.default = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7() {
  var startTime, _ret;

  return _regenerator2.default.wrap(function _callee7$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          startTime = new Date();

          _gulpUtil2.default.log(_gulpUtil2.default.colors.yellow('Loading gassetic.yml'));

          _context8.prev = 2;
          return _context8.delegateYield(_regenerator2.default.mark(function _callee6() {
            var env, command, config, steps, modules, hasErrors, allFiles;
            return _regenerator2.default.wrap(function _callee6$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    env = _yargs2.default.argv.env || 'dev';
                    command = _yargs2.default.argv._[0];
                    config = (0, _index.load)('gassetic.yml');

                    (0, _index.validate)(config);

                    steps = getBuildSteps(config);
                    modules = loadModules(config.requires);

                    // clear

                    _context7.next = 8;
                    return _promise2.default.all(steps.map(function () {
                      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(deps) {
                        return _regenerator2.default.wrap(function _callee2$(_context2) {
                          while (1) {
                            switch (_context2.prev = _context2.next) {
                              case 0:
                                return _context2.abrupt('return', _promise2.default.all(deps.map(function () {
                                  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(dep) {
                                    return _regenerator2.default.wrap(function _callee$(_context) {
                                      while (1) {
                                        switch (_context.prev = _context.next) {
                                          case 0:
                                            return _context.abrupt('return', (0, _del2.default)(config.mimetypes[dep][env].outputFolder));

                                          case 1:
                                          case 'end':
                                            return _context.stop();
                                        }
                                      }
                                    }, _callee, undefined);
                                  }));

                                  return function (_x2) {
                                    return _ref3.apply(this, arguments);
                                  };
                                }())));

                              case 1:
                              case 'end':
                                return _context2.stop();
                            }
                          }
                        }, _callee2, undefined);
                      }));

                      return function (_x) {
                        return _ref2.apply(this, arguments);
                      };
                    }()));

                  case 8:
                    if (!(command === 'clear')) {
                      _context7.next = 10;
                      break;
                    }

                    return _context7.abrupt('return', {
                      v: void 0
                    });

                  case 10:
                    if (!(steps.length == 0)) {
                      _context7.next = 12;
                      break;
                    }

                    return _context7.abrupt('return', {
                      v: void 0
                    });

                  case 12:
                    hasErrors = false;
                    _context7.next = 15;
                    return _promise2.default.all(steps.map(function () {
                      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(deps) {
                        var replacements, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step;

                        return _regenerator2.default.wrap(function _callee5$(_context6) {
                          while (1) {
                            switch (_context6.prev = _context6.next) {
                              case 0:
                                replacements = [];
                                _iteratorNormalCompletion = true;
                                _didIteratorError = false;
                                _iteratorError = undefined;
                                _context6.prev = 4;
                                _loop = _regenerator2.default.mark(function _loop() {
                                  var dep;
                                  return _regenerator2.default.wrap(function _loop$(_context5) {
                                    while (1) {
                                      switch (_context5.prev = _context5.next) {
                                        case 0:
                                          dep = _step.value;
                                          _context5.prev = 1;
                                          return _context5.delegateYield(_regenerator2.default.mark(function _callee4() {
                                            var tasks, startTaskTime, files;
                                            return _regenerator2.default.wrap(function _callee4$(_context4) {
                                              while (1) {
                                                switch (_context4.prev = _context4.next) {
                                                  case 0:
                                                    tasks = getTasks(modules, config.mimetypes[dep], env);
                                                    startTaskTime = new Date();


                                                    _gulpUtil2.default.log(_gulpUtil2.default.colors.magenta('▸') + ' compiling ' + _gulpUtil2.default.colors.cyan(dep) + ' with ' + _gulpUtil2.default.colors.gray(tasks.map(function (t) {
                                                      return t.name;
                                                    }).join(', ')));
                                                    _context4.next = 5;
                                                    return runTasks(config.mimetypes[dep].files, tasks, config.mimetypes[dep][env]);

                                                  case 5:
                                                    files = _context4.sent;

                                                    _gulpUtil2.default.log(_gulpUtil2.default.colors.green('✓') + ' ' + _gulpUtil2.default.colors.green(dep) + ' finished ' + _gulpUtil2.default.colors.gray('in ' + Math.round((new Date() - startTaskTime) / 10) / 100 + 's'));
                                                    replacements.push({
                                                      mimetype: dep,
                                                      htmlTag: config.mimetypes[dep][env].htmlTag || '<!-- missing htmlTag ' + dep + ' -> ' + env + ' -->',
                                                      files: files
                                                    });

                                                    if (env === 'dev' && command !== 'build') {
                                                      (0, _entries2.default)(config.mimetypes[dep].files).map(function (_ref5) {
                                                        var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
                                                            key = _ref6[0],
                                                            files = _ref6[1];

                                                        _gulpUtil2.default.log(_gulpUtil2.default.colors.white('▸ watching') + ' ' + _gulpUtil2.default.colors.gray(key));
                                                        _gulp2.default.watch(config.mimetypes[dep].watch || files, { maxListeners: Infinity }, (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
                                                          return _regenerator2.default.wrap(function _callee3$(_context3) {
                                                            while (1) {
                                                              switch (_context3.prev = _context3.next) {
                                                                case 0:
                                                                  _gulpUtil2.default.log(_gulpUtil2.default.colors.yellow('▸ compiling') + ' ' + _gulpUtil2.default.colors.cyan(dep));
                                                                  _context3.next = 3;
                                                                  return runTasks((0, _defineProperty3.default)({}, key, files), tasks, config.mimetypes[dep][env]);

                                                                case 3:
                                                                  _gulpUtil2.default.log(_gulpUtil2.default.colors.green('✓') + ' finished ' + _gulpUtil2.default.colors.cyan(dep));

                                                                case 4:
                                                                case 'end':
                                                                  return _context3.stop();
                                                              }
                                                            }
                                                          }, _callee3, undefined);
                                                        })));
                                                      });
                                                    }

                                                  case 9:
                                                  case 'end':
                                                    return _context4.stop();
                                                }
                                              }
                                            }, _callee4, undefined);
                                          })(), 't0', 3);

                                        case 3:
                                          _context5.next = 9;
                                          break;

                                        case 5:
                                          _context5.prev = 5;
                                          _context5.t1 = _context5['catch'](1);

                                          hasErrors = true;
                                          _gulpUtil2.default.log(_gulpUtil2.default.colors.red(_context5.t1));

                                        case 9:
                                        case 'end':
                                          return _context5.stop();
                                      }
                                    }
                                  }, _loop, undefined, [[1, 5]]);
                                });
                                _iterator = (0, _getIterator3.default)(deps);

                              case 7:
                                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                                  _context6.next = 12;
                                  break;
                                }

                                return _context6.delegateYield(_loop(), 't0', 9);

                              case 9:
                                _iteratorNormalCompletion = true;
                                _context6.next = 7;
                                break;

                              case 12:
                                _context6.next = 18;
                                break;

                              case 14:
                                _context6.prev = 14;
                                _context6.t1 = _context6['catch'](4);
                                _didIteratorError = true;
                                _iteratorError = _context6.t1;

                              case 18:
                                _context6.prev = 18;
                                _context6.prev = 19;

                                if (!_iteratorNormalCompletion && _iterator.return) {
                                  _iterator.return();
                                }

                              case 21:
                                _context6.prev = 21;

                                if (!_didIteratorError) {
                                  _context6.next = 24;
                                  break;
                                }

                                throw _iteratorError;

                              case 24:
                                return _context6.finish(21);

                              case 25:
                                return _context6.finish(18);

                              case 26:
                                return _context6.abrupt('return', replacements);

                              case 27:
                              case 'end':
                                return _context6.stop();
                            }
                          }
                        }, _callee5, undefined, [[4, 14, 18, 26], [19,, 21, 25]]);
                      }));

                      return function (_x3) {
                        return _ref4.apply(this, arguments);
                      };
                    }()));

                  case 15:
                    _context7.t0 = function (a, b) {
                      return a.concat(b);
                    };

                    _context7.t1 = function (a) {
                      return a.htmlTag;
                    };

                    allFiles = _context7.sent.reduce(_context7.t0).filter(_context7.t1);


                    _gulpUtil2.default.log(_gulpUtil2.default.colors.blue('Updating templates 📝'));
                    _context7.next = 21;
                    return replaceInTemplates(config.replacementPaths, allFiles, env);

                  case 21:
                    _gulpUtil2.default.log(_gulpUtil2.default.colors.blue('Creating gassetic.dump.' + env + '.yml'));
                    _context7.next = 24;
                    return createResultsFile(config.resultsFolder, allFiles, env);

                  case 24:
                    _gulpUtil2.default.log(_gulpUtil2.default.colors.green('Build finished in ' + Math.round((new Date() - startTime) / 10) / 100 + 's \uD83D\uDC4D'));
                    if (hasErrors) {
                      _gulpUtil2.default.log(_gulpUtil2.default.colors.red('But hey, there were errors'));
                      process.exit(1);
                    }

                  case 26:
                  case 'end':
                    return _context7.stop();
                }
              }
            }, _callee6, undefined);
          })(), 't0', 4);

        case 4:
          _ret = _context8.t0;

          if (!((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object")) {
            _context8.next = 7;
            break;
          }

          return _context8.abrupt('return', _ret.v);

        case 7:
          _context8.next = 13;
          break;

        case 9:
          _context8.prev = 9;
          _context8.t1 = _context8['catch'](2);

          _gulpUtil2.default.log(_gulpUtil2.default.colors.red(_context8.t1));
          process.exit(1);

        case 13:
        case 'end':
          return _context8.stop();
      }
    }
  }, _callee7, undefined, [[2, 9]]);
}));

// steps

var getBuildSteps = exports.getBuildSteps = function getBuildSteps(config) {
  return config.default.map(function (mimetype) {
    return getBuildStepDependency(config, mimetype);
  });
};

var getBuildStepDependency = function getBuildStepDependency(config, mimetype) {
  return (config.mimetypes[mimetype].deps || []).reduce(function (final, dep) {
    return getBuildStepDependency(config, dep).concat(final);
  }, [mimetype]);
};

// modules
var loadModules = function loadModules(requires) {
  module.paths.unshift(_path2.default.join(process.cwd(), 'node_modules'));
  module.paths.unshift(process.cwd());
  return (0, _entries2.default)(requires).reduce(function (registry, _ref8) {
    var _ref9 = (0, _slicedToArray3.default)(_ref8, 2),
        moduleKey = _ref9[0],
        module = _ref9[1];

    return (0, _extends4.default)({}, registry, (0, _defineProperty3.default)({}, moduleKey, require(module.startsWith('./') && _path2.default.join(process.cwd(), module) || module)));
  }, {});
};

// tasks
var getTasks = exports.getTasks = function getTasks(modules, mimetype, environment) {
  return mimetype[environment].tasks.map(function (task) {
    if (task.callback) {
      task.callback = modules[task.callback];
    }
    return (0, _extends4.default)({}, task, { fn: getModuleFunction(modules, task.name) });
  });
};

var getModuleFunction = function getModuleFunction(modules, taskName) {
  return taskName.split('.').reduce(function (scope, taskPart) {
    return scope[taskPart];
  }, modules);
};

var runTasks = exports.runTasks = function () {
  var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(files, tasks, _ref11) {
    var outputFolder = _ref11.outputFolder,
        webPath = _ref11.webPath;
    return _regenerator2.default.wrap(function _callee8$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _context9.next = 2;
            return _promise2.default.all((0, _keys2.default)(files).map(function (destFilename) {
              return new _promise2.default(function (resolve, reject) {
                try {
                  (function () {
                    var filesCreated = [];
                    [{ fn: _gulpPlumber2.default, callback: function callback(e) {
                        return reject(e);
                      } }].concat(tasks).reduce(function (pipe, nextTask) {
                      return pipe.pipe(nextTask.callback ? nextTask.fn(nextTask.callback) : replaceArguments(nextTask, { filename: destFilename })());
                    }, _gulp2.default.src(files[destFilename])).pipe(_gulp2.default.dest(_path2.default.join(outputFolder, destFilename))).pipe((0, _gulpTap2.default)(function (file) {
                      if (_yargs2.default.argv.print) _gulpUtil2.default.log(_gulpUtil2.default.colors.white('▸ ') + _gulpUtil2.default.colors.gray('compiled ' + file.path));

                      if (!webPath) return;
                      var filepath = file.path.substring(process.cwd().length).replace(outputFolder, '');
                      var fileWebPath = _path2.default.join(webPath, filepath);
                      filesCreated.push(fileWebPath);
                    })).on('end', function () {
                      return resolve((0, _defineProperty3.default)({}, destFilename, filesCreated));
                    });
                  })();
                } catch (e) {
                  reject(e);
                }
              });
            }));

          case 2:
            _context9.t0 = function (all, next) {
              return (0, _extends4.default)({}, all, next);
            };

            _context9.t1 = {};
            return _context9.abrupt('return', _context9.sent.reduce(_context9.t0, _context9.t1));

          case 5:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee8, undefined);
  }));

  return function runTasks(_x4, _x5, _x6) {
    return _ref10.apply(this, arguments);
  };
}();

var replaceArguments = function replaceArguments(_ref12, _ref13) {
  var fn = _ref12.fn,
      args = _ref12.args;
  var filename = _ref13.filename;
  return function () {
    return fn(JSON.parse((0, _stringify2.default)(args || '').replace('%filename%', filename)));
  };
};

// replacement paths
var replaceInTemplates = exports.replaceInTemplates = function replaceInTemplates(replacementPaths, files, environment) {
  return new _promise2.default(function () {
    var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(resolve, reject) {
      var templates;
      return _regenerator2.default.wrap(function _callee9$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.prev = 0;
              _context10.next = 3;
              return _promise2.default.all(replacementPaths.map(globPromised));

            case 3:
              _context10.t0 = function (a, b) {
                return a.concat(b);
              };

              templates = _context10.sent.reduce(_context10.t0);

              templates.forEach(function (template) {
                var content = files.reduce(function (newContent, mimetype) {
                  return (0, _entries2.default)(mimetype.files).reduce(function (newContent, _ref15) {
                    var _ref16 = (0, _slicedToArray3.default)(_ref15, 2),
                        destFilename = _ref16[0],
                        files = _ref16[1];

                    var scripts = files.map(function (path) {
                      return mimetype.htmlTag.replace('%path%', path);
                    });
                    return newContent.replace(new RegExp('([ \t]*)<!-- ' + environment + ':' + destFilename + ' -->([\\s\\S]*?)<!-- endbuild -->', 'ig'), '$1<!-- ' + environment + ':' + destFilename + ' -->\n$1' + scripts.map(function (script) {
                      return '  ' + script;
                    }).join('\n$1') + '\n$1<!-- endbuild -->');
                  }, newContent);
                }, _fs2.default.readFileSync(template, 'utf-8'));
                _fs2.default.writeFileSync(template, content);
              });
              resolve();
              _context10.next = 12;
              break;

            case 9:
              _context10.prev = 9;
              _context10.t1 = _context10['catch'](0);

              reject(_context10.t1);

            case 12:
            case 'end':
              return _context10.stop();
          }
        }
      }, _callee9, undefined, [[0, 9]]);
    }));

    return function (_x7, _x8) {
      return _ref14.apply(this, arguments);
    };
  }());
};

var createResultsFile = function createResultsFile() {
  var resultsFolder = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();
  var files = arguments[1];
  var environment = arguments[2];
  return new _promise2.default(function (resolve) {
    var dump = _jsYaml2.default.safeDump(files, { lineWidth: Infinity });
    _fs2.default.writeFileSync(_path2.default.join(resultsFolder, 'gassetic.dump.' + environment + '.yml'), dump, 'utf-8');
    resolve();
  });
};

var globPromised = function globPromised(pattern) {
  return new _promise2.default(function (resolve) {
    return (0, _glob2.default)(pattern, {}, function (err, matches) {
      return resolve(matches);
    });
  });
};